module compute_neiKDtree_common
   implicit none
   integer, parameter :: nparmax=512*512*512
   character*9 :: distances='distances', &
 &                neighbors='neighbors', &
 &                adaptahop='adaptahop', &
 &               posttreatm='posttreat'
   integer, parameter :: nparbuffer=128**3
   integer, parameter :: ncellbuffermin=128**3
   integer, parameter :: nlevelmax=30,npartpercell=20
   integer :: lin=10,lsin=11,lin2=12
   integer :: loudis=12,lounei=13,lounode=14,loupartnode=15,lounodedyn=16
   real(kind=4)  :: pi=3.14159265359
   real(kind=4)  :: bignum=1.e30
   ! Physical constants (units : m s kg) ->
   real(kind=8), parameter :: gravitational_constant=6.6726d-11
   real(kind=8), parameter :: critical_density= 1.8788d-26
   real(kind=8), parameter :: mega_parsec=3.0857d22
   real(kind=8), parameter :: solar_mass=1.989d30
   real(kind=8), parameter :: convert_in_mps2=1.d6
   ! <-

   character*9 :: action
   character*255 :: filein,filedis,filenei,filenode,config,filepartnode, &
 &                  filenodedyn,fileinpartnode
   real(kind=4), allocatable :: pos(:,:)
   real(kind=4), allocatable :: vel(:,:)
   real(kind=4), allocatable :: masspart(:)
   real(kind=4), allocatable :: vxout(:),vyout(:),vzout(:),vdisout(:)
   integer, allocatable :: mass_cell(:)

   real(kind=8), allocatable :: tmass_cell(:)
   real(kind=8), allocatable :: vcell(:,:)

   real(kind=4), allocatable :: size_cell(:)
   real(kind=4), allocatable :: pos_cell(:,:)
   integer, allocatable :: sister(:)
   integer, allocatable :: firstchild(:)
   integer, allocatable :: idpart(:),idpart_tmp(:)
   integer, allocatable :: iparneigh(:,:)
   real(kind=8), allocatable :: distance(:)
   real(kind=4), allocatable :: density(:)
   integer, allocatable :: firstpart(:),nmemb(:)
   integer, allocatable :: igrouppart(:)
   integer, allocatable :: idgroup(:),idgroup_tmp(:)
   integer, allocatable :: igroupid(:)
   integer, allocatable :: color(:)
   integer, allocatable :: partnode(:)
   real(kind=4), allocatable :: densityg(:)
   real(kind=4) :: sizeroot
   real(kind=8) :: xlong, ylong, zlong, boxsize, boxsize2
   real(kind=8) :: xlongs2, ylongs2, zlongs2
   real(kind=8) :: hubble,omega0,omegaL,aexp,mass_in_kg,GMphys, &
 &                 aexp_hubble_const,aexp_mega_parsec_sqrt3, &
 &                 aexp_mega_parsec,aexp_max
   integer :: npart,npart_true,nvoisins,ncellmx,nhop,ntype
   integer :: ngroups,nmembthresh,nnodes,nnodesmax
   integer :: ncpu,nmpi,niterations,ncellbuffer
   real(kind=4) :: rho_threshold
   logical :: outnei,outdis,outgtree,verbose,megaverbose, &
 &            formatted,periodic,velocities,partinfo,simu_units, &
 &            remove_degenerate,posttreatment,formattedpartnode, &
 &            formattedinpartnode
   real(kind=8)  :: mtot,Ltot
   real(kind=8)  :: fudge,alpha,epsilon,fudgepsilon
   real(kind=8)  :: massrenorm,pos_shift(3),pos_renorm,velrenorm

   type grp
      sequence
      integer :: nhnei
      integer :: njunk ! To avoid missalignement in memory
      integer, dimension(:),pointer :: isad_gr(:)
      real(kind=4),  dimension(:),pointer :: rho_saddle_gr(:)
   end type grp

   type supernode
      sequence
      integer      :: level
      integer      :: mother
      integer      :: firstchild
      integer      :: nsisters
      integer      :: sister
      real(kind=4) :: rho_saddle
      real(kind=4) :: density
      real(kind=4) :: densmax
      real(kind=4) :: radius
      integer      :: mass
      real(kind=4) :: truemass
      real(kind=4) :: position(3)
   end type supernode

   type supernodedyn
      sequence
      integer      :: level
      integer      :: mother
      integer      :: firstchild
      integer      :: sister
      integer      :: oldindex
      integer      :: mass
      real(kind=8) :: truemass
      real(kind=8) :: radius
      real(kind=8) :: position(3)
      real(kind=8) :: velocity(3)
   end type supernodedyn

   type (grp), allocatable :: group(:)
   type (supernode), allocatable :: node(:)
   type (supernodedyn), allocatable :: nodedyn(:)

end module compute_neiKDtree_common
